SystemOrganization addCategory: #TGListModel!

Object subclass: #TGListModel
	instanceVariableNames: 'list selectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TGListModel'!

!TGListModel methodsFor: 'testing' stamp: 'HwaJong 11/13/2012 17:48'!
atEnd
	^ self list size = self selectionIndex! !

!TGListModel methodsFor: 'list manipulation' stamp: 'HwaJong 11/13/2012 18:04'!
atEndInsert: anObject

	self insert: anObject at: list size! !

!TGListModel methodsFor: 'private' stamp: 'HwaJong 1/31/2013 10:59'!
correctSelectionIndex
	selectionIndex < 0 ifTrue: [^self selectNone].
	list
		ifNil:[self selectNone]
		ifNotNil: [
			list isEmpty
				ifTrue: [self selectNone]
				ifFalse: [selectionIndex > list size ifTrue: [self selectNone]]].
	! !

!TGListModel methodsFor: 'list manipulation' stamp: 'HwaJong 1/31/2013 10:45'!
delete: anObject
	|delIndex|
	delIndex := list indexOf: anObject.
	list isEmpty ifTrue: [^self].
	list := (list copyFrom: 1 to: delIndex-1), (list copyFrom: delIndex+1 to: list size).
	delIndex < selectionIndex
		ifTrue: [selectionIndex:=selectionIndex-1]
		ifFalse: [
			delIndex = selectionIndex
				ifTrue: [self selectNone]
				ifFalse: []].
	selectionIndex > list size 
		ifTrue: [selectionIndex := list size].! !

!TGListModel methodsFor: 'list manipulation' stamp: 'HwaJong 11/13/2012 17:50'!
deleteSelection

	list isEmpty ifTrue: [^self].
	list := (list copyFrom: 1 to: selectionIndex-1), (list copyFrom: selectionIndex+1 to: list size).
	selectionIndex > list size ifTrue: [selectionIndex := list size].! !

!TGListModel methodsFor: 'testing' stamp: 'HwaJong 11/13/2012 17:52'!
hasSelection

	^list isEmpty not and: [selectionIndex > 0]! !

!TGListModel methodsFor: 'controlling' stamp: 'HwaJong 2/5/2013 15:56'!
ifHasSelection: block
	^self 
		ifHasSelection: [:object| block value: object] 
		ifDoesNotHaveSelection: []! !

!TGListModel methodsFor: 'controlling' stamp: 'HwaJong 1/4/2013 11:56'!
ifHasSelection: block1 ifDoesNotHaveSelection: block2
	^self hasSelection
		ifTrue: [block1 value: self selection]
		ifFalse: [block2 value]! !

!TGListModel methodsFor: 'initialization' stamp: 'HwaJong 1/23/2013 11:23'!
initialize

	super initialize.
	list := Array new.
	self selectNone.! !

!TGListModel methodsFor: 'list manipulation' stamp: 'HwaJong 11/13/2012 17:54'!
insert: anObject at: anInteger

	(anInteger between: 1 and: list size)
		ifTrue: [ list := (list copyFrom: 1 to: anInteger), (Array with: anObject), (list copyFrom:anInteger+1 to: list size).
			selectionIndex := anInteger+1]
		ifFalse: [list := Array with: anObject.
			selectionIndex := 1 ].! !

!TGListModel methodsFor: 'list manipulation' stamp: 'HwaJong 3/1/2013 23:23'!
insertAfterSelection: anObject 
	self insert: anObject at: selectionIndex	! !

!TGListModel methodsFor: 'list manipulation' stamp: 'HwaJong 11/13/2012 17:54'!
insertAll: anArray at: anInteger

	list := Array streamContents: [:stream| 
		stream nextPutAll: (list copyFrom: 1 to: anInteger).
		stream nextPutAll: anArray.
		stream nextPutAll: (list copyFrom: anInteger+1 to: list size).
		].
	selectionIndex := anInteger + anArray size.

	! !

!TGListModel methodsFor: 'accessing' stamp: 'HwaJong 11/13/2012 17:55'!
list
	^ list! !

!TGListModel methodsFor: 'accessing' stamp: 'HwaJong 1/31/2013 10:40'!
list: anOrderedCollection
	list := anOrderedCollection.
	self correctSelectionIndex
! !

!TGListModel methodsFor: 'list manipulation' stamp: 'HwaJong 11/13/2012 17:56'!
moveSelectionDown

	selectionIndex = list size ifTrue: [^self].
	list swap: selectionIndex with: selectionIndex+1.
	selectionIndex := selectionIndex + 1.! !

!TGListModel methodsFor: 'list manipulation' stamp: 'HwaJong 11/13/2012 17:56'!
moveSelectionUp

	selectionIndex = 1 ifTrue: [^self].
	list swap: selectionIndex-1 with: selectionIndex.
	selectionIndex := selectionIndex-1.! !

!TGListModel methodsFor: 'testing' stamp: 'HwaJong 11/13/2012 18:02'!
notEmpty
^list notEmpty! !

!TGListModel methodsFor: 'initialization' stamp: 'HwaJong 1/23/2013 11:16'!
selectNone
	selectionIndex := 0! !

!TGListModel methodsFor: 'self evaluating' stamp: 'HwaJong 11/13/2012 18:00'!
selection
	^self list at: self selectionIndex! !

!TGListModel methodsFor: 'accessing' stamp: 'HwaJong 11/13/2012 17:57'!
selectionIndex
	^ selectionIndex! !

!TGListModel methodsFor: 'accessing' stamp: 'HwaJong 11/13/2012 17:57'!
selectionIndex: anInteger
	selectionIndex := anInteger
! !

TGListModel subclass: #TGMultiSelectionListModel
	instanceVariableNames: 'selectionBools'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TGListModel'!

!TGMultiSelectionListModel methodsFor: 'multi selection' stamp: 'HwaJong 2/25/2013 12:59'!
atIndex: anInteger isSelected: aBoolean
	selectionBools at: anInteger put: aBoolean! !

!TGMultiSelectionListModel methodsFor: 'testing' stamp: 'HwaJong 2/25/2013 12:59'!
isSelectedAtIndex: anInteger
	^selectionBools at: anInteger! !

!TGMultiSelectionListModel methodsFor: 'accessing' stamp: 'HwaJong 2/25/2013 12:58'!
list: anArray
	super list: anArray.
	selectionBools := anArray collect: [:each| false]! !

!TGMultiSelectionListModel methodsFor: 'multi selection' stamp: 'HwaJong 2/25/2013 13:11'!
selections
	^Array streamContents: [:stream| (1 to: list size) do: [:index|
			(selectionBools at: index)
				ifTrue: [stream nextPut: (list at: index) ] ] ]! !

!TGMultiSelectionListModel methodsFor: 'multi selection' stamp: 'HwaJong 2/25/2013 16:11'!
selections: anArray 
	selectionBools := list collect: [:each| anArray includes: each]! !

TestCase subclass: #TGListModelTest
	instanceVariableNames: 'lm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TGListModel'!

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2013 23:26'!
testDelete

	lm := TGListModel new.
	lm list: 'abcde'.
	lm selectionIndex: 3.
	self assert: lm selection equals: $c.
	lm delete: $b.
	self assert: lm list equals: 'acde'.
	self assert: lm selection equals: $c.
	self assert: lm selectionIndex equals: 2.
	
	lm := TGListModel new.
	lm list: 'abcde'.
	lm selectionIndex: 3.
	self assert: lm selection equals: $c.
	lm delete: $d.
	self assert: lm list equals: 'abce'.
	self assert: lm selection equals: $c.
	self assert: lm selectionIndex equals: 3.
	
	lm := TGListModel new.
	lm list: 'abcde'.
	lm selectionIndex: 3.
	self assert: lm selection equals: $c.
	lm delete: $c.
	self assert: lm list equals: 'abde'.
	self deny: lm hasSelection
! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2013 23:26'!
testDeleteSelection

	lm := TGListModel new.
	lm list: {1. 2. 3}.
	lm selectionIndex: 3.
	lm deleteSelection.
	self assert: {1. 2} equals: lm list.
	self assert: 2 equals: lm selectionIndex.
	lm deleteSelection.	
	self assert: {1} equals: lm list.
	self assert: 1 equals: lm selectionIndex.
	lm deleteSelection.	
	self assert: {} equals: lm list.
	self assert: 0 equals: lm selectionIndex.
	"sanity test"
	lm insert: 100 at: 1.
	self assert: {100} equals: lm list.
	self assert: 1 equals: lm selectionIndex.
! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2013 23:26'!
testInsertAllAt

	lm := TGListModel new.
	lm list: {1. 2. 3. 4. 5}.
	lm selectionIndex: 3.
	lm insertAll: {6. 7. 8. 9} at: 4.
	self assert: {1. 2. 3. 4. 6. 7. 8. 9. 5} equals: lm list.
	self assert: 8 equals: lm selectionIndex.
! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2013 23:26'!
testInsertAt

	lm := TGListModel new.
	lm insert: 'hi' at: 1.
	self assert: {'hi'} equals: lm list.
	self assert: 1 equals: lm selectionIndex.
	lm insert: 'there' at: 1.
	self assert: {'hi'. 'there'} equals: lm list.
	self assert: 2 equals: lm selectionIndex.
	lm insert: 'you' at: 1.
	self assert: {'hi'. 'you'. 'there'} equals: lm list.
	self assert: 2 equals: lm selectionIndex.
	lm insert: 'lala' at: 3.
	self assert: {'hi'. 'you'. 'there'. 'lala'} equals: lm list.
	self assert: 4 equals: lm selectionIndex.
! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2013 23:26'!
testInsertInsaneIndex

	lm := TGListModel new.
	lm insert: 'hi' at: 29.
	self assert: {'hi'} equals: lm list.
	self assert: 1 equals: lm selectionIndex.! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2013 23:26'!
testMoveSelectionDown

	lm := TGListModel new.
	lm list: {1. 2. 3. 4. 5}.
	lm selectionIndex: 3.
	lm moveSelectionDown.	
	self assert: {1. 2. 4. 3. 5} equals: lm list.
	self assert: 4 equals: lm selectionIndex.
	lm moveSelectionDown.
	self assert: {1. 2. 4. 5. 3} equals: lm list.
	self assert: 5 equals: lm selectionIndex.
	lm moveSelectionDown.
	self assert: {1. 2. 4. 5. 3} equals: lm list.
	self assert: 5 equals: lm selectionIndex.
! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2013 23:26'!
testMoveSelectionUp

	lm := TGListModel new.
	lm list: {1. 2. 3. 4. 5}.
	lm selectionIndex: 3.
	lm moveSelectionUp.	
	self assert: {1. 3. 2. 4. 5} equals: lm list.
	self assert: 2 equals: lm selectionIndex.
	lm moveSelectionUp.
	self assert: {3. 1. 2. 4. 5} equals: lm list.
	self assert: 1 equals: lm selectionIndex.
	lm moveSelectionUp.
	self assert: {3. 1. 2. 4. 5} equals: lm list.
	self assert: 1 equals: lm selectionIndex.! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2013 23:26'!
testMoveSelectionUpDownWithOneItem

	lm := TGListModel new.
	lm list: {3}.
	lm selectionIndex: 1.
	lm moveSelectionUp.
	self assert: {3} equals: lm list.
	self assert: 1 equals: lm selectionIndex.
	lm moveSelectionDown.
	self assert: {3} equals: lm list.
	self assert: 1 equals: lm selectionIndex.
! !

!TGListModelTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2013 23:26'!
testSettingListCorrectsSelectionIndex

	lm := TGListModel new.
	lm selectionIndex: 2900.
	self assert: lm selectionIndex equals: 2900.
	lm list: {}.
	self assert: lm selectionIndex equals: 0.
	
	lm := TGListModel new.
	lm selectionIndex: 2900.
	self assert: lm selectionIndex equals: 2900.
	lm list: nil.
	self assert: lm selectionIndex equals: 0.
	
	lm := TGListModel new.
	lm selectionIndex: 2900.
	self assert: lm selectionIndex equals: 2900.
	lm list: {1. 2. 3}.
	self assert: lm selectionIndex equals: 0.! !

TestCase subclass: #TGMultiSelectionListModelTest
	instanceVariableNames: 'lm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TGListModel'!

!TGMultiSelectionListModelTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2013 23:33'!
setUp
	super setUp.
	lm := TGMultiSelectionListModel new.
	lm list: {'apple'. 'banana'. 'carrot'. 'doom'}.! !

!TGMultiSelectionListModelTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2013 23:33'!
testAtIndexIsSelected
	self assert: lm selections equals: {}.
	
	lm atIndex: 1 isSelected: true.
	lm atIndex: 4 isSelected: true.
	lm selections: {'apple'. 'doom'}.
	self assert: lm selections equals: {'apple'. 'doom'}.! !

!TGMultiSelectionListModelTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2013 23:35'!
testIsSelectedAtIndex
	self deny: (lm isSelectedAtIndex: 1).
	self deny: (lm isSelectedAtIndex: 2).
	self deny: (lm isSelectedAtIndex: 3).
	self deny: (lm isSelectedAtIndex: 4).
	
	lm selections: {'banana'. 'doom'}.
	self deny: (lm isSelectedAtIndex: 1).
	self assert: (lm isSelectedAtIndex: 2).
	self deny: (lm isSelectedAtIndex: 3).
	self assert: (lm isSelectedAtIndex: 4).

	! !

!TGMultiSelectionListModelTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 3/1/2013 23:33'!
testSelections
	self assert: lm selections equals: {}.
	
	lm selections: {'banana'. 'doom'}.
	self assert: lm selections equals: {'banana'. 'doom'}.! !
